
void copy(int n1, int n2, double **a, double **b);
void sanjo(int n1, int n2, double **a, double **b);
double expo(int k1, int k2, double t);
void linear_time_evolution(int n1, int n2, double t, double **a, double **b);
void function1(double **a, double **b, double time);
void function2(double **a, double **b, double **c, double t);
void function3(double **a , double **b, double **c, double **d, double t);
void inputdata2d(int n1, int n2, double **a);
void outputdata2d(int n1, int n2, double **a);
void time_evolution();

void copy (int n1, int n2, double **a, double **b)//abɈڂ
{
	int j1, j2;

	for (j1 = 0; j1 < n1; j1++){
		for (j2 = 0; j2 < 2*n2; j2++){
			b[j1][j2] = a[j1][j2];
		}
	}
}

void sanjo(int n1, int n2, double **a, double **b)//a̎ObƂB
{
    int j1, j2;

    for (j1 = 0; j1 < n1; j1++) {
        for (j2 = 0; j2 < n2; j2++) {
            b[j1][2*j2] = a[j1][2*j2]*a[j1][2*j2]*a[j1][2*j2] - 3*a[j1][2*j2]*a[j1][2*j2+1]*a[j1][2*j2+1];//
			b[j1][2*j2+1] = 3*a[j1][2*j2]*a[j1][2*j2]*a[j1][2*j2+1] - a[j1][2*j2+1]*a[j1][2*j2+1]*a[j1][2*j2+1];//
        }
    }
}

double expo(int k1, int k2, double t)//^exp(~)邱ƂɂȂ邪̒ǧvZ
{
	double d, k_2, G_k;
	
	if(k1 > N/2-1)
		k1 = N-k1;
	else
		k1 = k1;
	if(k2 > N/2 -1)
		k2 = N-k2;
	else
		k2 = k2;

	k_2 = 4 * M_PI * M_PI * (k1*k1+k2*k2) / (N*N);
	G_k = 4 - 2 * M_PI * sqrt(k_2);
	d = exp((alpha - beta * k_2 - gamma * G_k)*t);

	return (d);
}

void linear_time_evolution(int n1, int n2, double t, double **a, double **b)
{
	int j1, j2;

    for (j1 = 0; j1 < n1; j1++) {
        for (j2 = 0; j2 < n2; j2++) {
			b[j1][j2*2] = a[j1][j2*2] * expo(j1, j2, t);
			b[j1][j2*2+1] = a[j1][j2*2+1] * expo(j1, j2, t);
		}
	}
}


void function1(double **a, double **b, double time)
{
	int *ip,  m, i;
	int j1, j2 ;
	double **t, *w;

    t = alloc_2d_double(N, 2*N);
    ip = alloc_1d_int(2 + (int) sqrt(N + 0.5));
    m = N/2 + 2*N;
    w = alloc_1d_double(m);
    ip[0] = 0;

	cdft2d(N, 2*N, -1, a, ip, w);//tt[Gϊ@a[k1][k2]  a[j1][j2]
	for (j1 = 0; j1 < N; j1++) {
		for (j2 = 0; j2 < 2 * N; j2++) {
			a[j1][j2] *= 1.0 / (N * N);
		}
	}

	sanjo(N, N, a, b);//b=a^3
	cdft2d(N, 2*N, 1, b, ip, w);//t[Gϊ

	for(j1=0; j1<N; ++j1){
		for(j2=0; j2<N; ++j2){
			b[j1][j2*2] = -alpha_2*b[j1][j2*2];
			if((j1==0)&&(hini - v*time > 0)&&(j2==0)){b[j1][j2*2] = b[j1][j2*2] + hini - v*time;}//
			b[j1][j2*2+1] = -alpha_2*b[j1][j2*2+1];//
		}
	}
	free_1d_double(w);//YĂ܂B
    free_1d_int(ip);
	free_2d_double(t);
}


void function2(double **a, double **b, double **c, double t)
{
	int j1, j2;
	for (j1=0; j1<N ; ++j1){
		for(j2=0; j2<N ;++j2){
			c[j1][j2*2] = a[j1][j2*2] + b[j1][j2*2] *t;//
			c[j1][j2*2+1] = a[j1][j2*2+1] + b[j1][j2*2+1] *t;//
		}
	}
}

void function3(double **a , double **b, double **c, double **d, double t)
{
	int j1, j2;
	for (j1=0; j1<N ; ++j1){
		for(j2=0; j2<N ;++j2){
			d[j1][j2*2] = a[j1][j2*2] + (b[j1][j2*2] + c[j1][j2*2])*t/2;//
			d[j1][j2*2+1] = a[j1][j2*2+1] + (b[j1][j2*2+1] + c[j1][j2*2+1])*t/2;//
		}
	}
}

void inputdata2d(int n1, int n2, double **a)
{
    int j1, j2;

    for (j1 = 0; j1 < n1; j1++) {
        for (j2 = 0; j2 < n2; j2++) {
            a[j1][2*j2] = g_array[j1][j2];//
			a[j1][2*j2+1] = 0;//
        }
    }
}

void outputdata2d(int n1, int n2, double **a)
{
	    int j1, j2;

    for (j1 = 0; j1 < n1; j1++) {
        for (j2 = 0; j2 < n2; j2++) {
			g_array[j1][j2] = a[j1][2*j2];
		}
	}
}

void time_evolution()
{
	int *ip,  m, i;
	int j1, j2 ;
	double **a, **b, **c, **d, **t, *w;

	a = alloc_2d_double(N, 2*N);
	b = alloc_2d_double(N, 2*N);
	c = alloc_2d_double(N, 2*N);
	d = alloc_2d_double(N, 2*N);

    t = alloc_2d_double(N, 2*N);
    ip = alloc_1d_int(2 + (int) sqrt(N + 0.5));
    m = N/2 + 2*N;
    w = alloc_1d_double(m);
    ip[0] = 0;
    

	inputdata2d(N, N, a);//g_array[][] 𕡑f̔z a[][] Ɋg@TCYN*NN*2N

	cdft2d(N, 2*N, 1, a, ip, w);//a[j1][j2]Fourierϊ  a[k1][k2]

	linear_time_evolution(N, N, dt, a, b);//ba̐^ԔW(dt)

	function1(a, c, steps*dt);//a͋tt[GϊŖ߂Ac͔`WłB

	function2(b, c ,a, dt);//a = b + c*dt

	function1(a, d, steps*dt +dt);//a͋tt[GϊŖ߂Ad͔`WłB

	function3(b, c, d, a, dt);//a = b +(c+d)*dt/2

    cdft2d(N, 2*N, -1, a, ip, w);//tt[Gϊ@a[k1][k2]  a[j1][j2]

	for (j1 = 0; j1 < N; j1++) {
		for (j2 = 0; j2 < 2 * N; j2++) {
			a[j1][j2] *= 1.0 / (N * N);
		}
	}
	
	outputdata2d(N, N, a );

	steps = steps+1;
	printf("Steps = %d\n", steps);

    free_1d_double(w);
    free_1d_int(ip);
    free_2d_double(t);
    free_2d_double(a);
	free_2d_double(b);
	free_2d_double(c);
	free_2d_double(d);

}